/**
	Definitions for canvas object
	Fraga Nov 5, 2001
**/
#ifndef CANVAS_H
#define CANVAS_H

#include <qwidget.h>
#include <qgl.h>
#include <qtimer.h>
#include "cylinder.h"

class Canvas : public QGLWidget
{
	Q_OBJECT  // must include this if you use Qt signals/slots
public:
	Canvas( QWidget *parent=0, const char *name=0 );
	QSizePolicy sizePolicy() const;
	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *w, int *h ) { 
		*w = windowWidth; *h = windowHeight; 
	}

public slots:
	void timerDone( void );
	void initscreen( void ) { 
		timer->start(500);
	}
	void stop( void ) {
		timer->stop( );
 	} 
	void shade_model( int n ) {
		if ( n != shade ) {
			shade = n;
			updateGL( );
		}
	}
	void system_model( int n ) {
		coordinates = n;
	}

signals:
	void changePos( ); // called when mouse is moved
	void changeSize( ); // called when windows is resized
 
protected:
	void initializeGL( void );
	void resizeGL( int w, int h );
	void paintGL( void );
	void mouseMoveEvent( QMouseEvent * );
	void InitMaterials( void );
	void keyPressEvent ( QKeyEvent * e );
	// void mousePressEvent( QMouseEvent * );
 
 
private:

	QTimer *timer;

	int windowWidth, windowHeight;   // canvas width and height

	float yrot, xrot;  // Encene rotation
	int coordinates;
        
	float scale;
	float angle;
	int signo, shade;
	int xmouse, ymouse;  // Mouse pointer coordinates
	Cylinder *cylinder1;
};


#endif // CYLINDER_H
