/** 
	 Class Cylinder

	Fraga. 10 november 2003
**/
 
#include <math.h>
#include "cylinder.h"

Cylinder::Cylinder( float height, float radius)
{
	getcone( height, radius );

	R = G = B = 1.0;  // white by default
}

/** 
	Funcitn to generate a cylunder with center (0,0,0)
**/
void Cylinder::getcone ( float h, float r )
{
	int i;

	z0 = h/2.0; 
	z1 = -z0;

	float incrang = 360.0/NPOINTS;


	for ( i=0; i<NPOINTS; i++ ) { 
		float theta = i*incrang;

		theta *= M_PI/180.0;

		float sintheta = sin ( theta );
		float costheta = cos ( theta );

		v[i][0] = r * costheta; 
		v[i][1] = r * sintheta;

		theta = i*incrang + incrang/2;
		theta *= M_PI/180.0;
		sintheta = sin ( theta );
		costheta = cos ( theta );

		normals[i][0] = sintheta;
		normals[i][1] = costheta;
		normals[i][2] = 0.0;
	}
}

void Cylinder::color(float x,float y,float z)
{
  R = x;
  G = y;
  B = z;
}

void Cylinder::show (  )
{
	int i;

	for (i = 0; i < NPOINTS; i++) {
		glBegin(GL_QUADS);

		int j = (i+1)%NPOINTS;

		glColor3f( R, G, B );
		glVertex3f( v[i][0], z1, v[i][1] );
		glVertex3f( v[j][0], z1, v[j][1] );

		glColor3f( 1.0, 1.0, 1.0 );
		glVertex3f( v[j][0], z0, v[j][1] );
		glVertex3f( v[i][0], z0, v[i][1] );


		glNormal3fv( &normals[i][0]);

		glEnd();
	}
}

